/*//////////////////////////////////////////////////////////////////////
                           Necessary Includes
//////////////////////////////////////////////////////////////////////*/

// this is a good example for insecure code ;-)

#include <windows.h>
#include <ida.hpp>
#include <idp.hpp>
#include <loader.hpp>
#include <diskio.hpp>


char * ver = "0.11";
char filename[MAXSTR];

char * opendate = "DATE";
char * opened = "OPENED";
char * closed = "CLOSED";
char * duration = "DURATION";

char datebuf[20];
char durbuf[20];
char curtime[20];
char runsection[30];
char commnum[30];

SYSTEMTIME systime;

DWORD tickstart,tickend;
DWORD hours,minutes,seconds;

char *askform =
		"startitem 2\n"
		"HELP\n"
		"%s\n"
		"ENDHELP\n"
		"Enter additional comment for this session\n\n"
		"<#comment#~C~omment:A:255:32::>\n\n";


char myhelp[] =
        "attendance recorder\n"
        "\n"
        "This plugin records access to every file/idb.\n"
        "Date, Time and duration will be stored\n"
        "in a log file in your IDA directory.\n"
        "You can add up to 9999 comments for each run\n"
        "by selecting the plugin from the menu.\n\n";


bool IsSectionPresent(char * section,char * filename)
{
	char buf[MAXSTR];

	if ( GetPrivateProfileSection(section,buf,sizeof(buf),filename) == 0 )
		return false;
return true;
}

bool IsStringPresent(char * section,char * key,char * filename)
{
	char buf[MAXSTR];

	if ( GetPrivateProfileString(section,key,"",buf,sizeof(buf),filename) == 0 )
		return false;
return true;
}

/*//////////////////////////////////////////////////////////////////////
                  EXTERNALLY VISIBLE CODE STARTS HERE
//////////////////////////////////////////////////////////////////////*/


//----------------------------------------------------------------------

/*----------------------------------------------------------------------
FUNCTION        :   plugin_main
DISCUSSION      :
    The entry point for this plugin
PARAMETERS      :
    argc - The number of commmand line arguments
    argv - The array of commmand line arguments
RETURNS         :
    0 - Life is good and everything processed fine.
    1 - There was a general problem.
    2 - The module either did not have symbols or did not have symbols
        that supported line information.
----------------------------------------------------------------------*/
void plugin_main(int)
{
	char answer[280]="";
	int i=1;;

	tickend=GetTickCount();
	tickend-=tickstart;

	hours = tickend / 3600000;	  
	minutes = ( tickend / 60000 ) % 60;
	seconds = ( tickend / 1000 ) % 60;

	msg("attendance recorder v%s\n",ver);
	msg("time is money ;-)\n");
	msg("output filename is: %s\n",filename);
	msg("time spent/wasted on this database: %02dh %02dm %02ds\n",hours,minutes,seconds);

	sprintf(commnum,"COMMENT%04d\0",i);

	while(IsStringPresent(runsection,commnum,filename))
	{
		i++;
		sprintf(commnum,"COMMENT%04d\0",i);
	}

	if (AskUsingForm_c(askform, myhelp, &answer, &answer))
	{
		WritePrivateProfileString(runsection,commnum,answer,filename);
		msg("Comment number %d added:\n%s\n",i,answer);
	}
}

/*//////////////////////////////////////////////////////////////////////
                      IDA PRO INTERFACE START HERE
//////////////////////////////////////////////////////////////////////*/
//--------------------------------------------------------------------------
//
//      initialize plugin
//
//      IDA will call this function only once.
//      If this function returns PLGUIN_SKIP, IDA will never load it again.
//      If this function returns PLUGIN_OK, IDA will unload the plugin but
//      remember that the plugin agreed to work with the database.
//      The plugin will be loaded again if the user invokes it by
//      pressing the hotkey or selecting it from the menu.
//      After the second load the plugin will stay on memory.
//
//      In this example we check the input file format and make the decision.
//      You may or may not check any other conditions to decide what you do:
//      whether you agree to work with the database or not.
//

int init(void)
{
	int i = 1;

	tickstart=GetTickCount();

	strcpy(filename,idadir());
	strcat(filename,"\\");
	strcat(filename,get_root_filename());
	strcat(filename,".log");
	sprintf(runsection,"RUN%04d\0",i);

	while(IsSectionPresent(runsection,filename))
	{
		i++;
		sprintf(runsection,"RUN%04d\0",i);
	}

	WritePrivateProfileSection(runsection,"\0",(LPCTSTR)&filename);
	GetSystemTime(&systime);
	sprintf(datebuf,"%02d.%02d.%d\0",systime.wDay,systime.wMonth,systime.wYear);
	sprintf(curtime,"%02d:%02d:%02d\0",++systime.wHour,systime.wMinute,systime.wSecond);
	WritePrivateProfileString(runsection,opendate,datebuf,filename);
	WritePrivateProfileString(runsection,opened,curtime,filename);
	if(systime.wDayOfWeek==1) msg("Oh my gosh.. it's monday again.. headache and shit..ewww.\n");
	return PLUGIN_KEEP;
}

//--------------------------------------------------------------------------
//      terminate
//      usually this callback is empty
//
//      IDA will call this function when the user asks to exit.
//      This function won't be called in the case of emergency exits.

void term(void)
{

	tickend=GetTickCount();
	tickend-=tickstart;

	hours = tickend / 3600000;
	minutes = ( tickend / 60000 ) % 60;
	seconds = ( tickend / 1000 ) % 60;

	GetSystemTime(&systime);

	sprintf(curtime,"%02d:%02d:%02d\0",++systime.wHour,systime.wMinute,systime.wSecond);
	WritePrivateProfileString(runsection,closed,curtime,filename);
	sprintf(durbuf,"%02d:%02d:%02d\r\n\0",hours,minutes,seconds);
	WritePrivateProfileString(runsection,duration,durbuf,filename);
}

char comment[] = "attendance recorder";

char help[] =
"time is money!\n";

//--------------------------------------------------------------------------
// This is the preferred name of the plugin module in the menu system
// The preferred name may be overriden in plugins.cfg file

char wanted_name[] = "attendance recorder";


// This is the preferred hotkey for the plugin module
// The preferred hotkey may be overriden in plugins.cfg file
// Note: IDA won't tell you if the hotkey is not correct
//       It will just disable the hotkey.

char wanted_hotkey[] = "SHIFT-C"; // Ctrl-F12 is used to draw function call graph now
                           // No hotkey for PDB files, but since it is not
                           // used very often, it is tolerable

//--------------------------------------------------------------------------
//
//      PLUGIN DESCRIPTION BLOCK
//
//--------------------------------------------------------------------------

extern "C" plugin_t PLUGIN =
{
  IDP_INTERFACE_VERSION,
  0,                    // plugin flags
  init,                 // initialize

  term,                 // terminate. this pointer may be NULL.

  plugin_main,          // invoke plugin

  comment,              // long comment about the plugin
                        // it could appear in the status line
                        // or as a hint

  help,                 // multiline help about the plugin

  wanted_name,          // the preferred short name of the plugin
  wanted_hotkey         // the preferred hotkey to run the plugin
};

